jvx.geom

## Class PwBlocks

- java.lang.Object
- - jv.object.PsObject
  - - jvx.project.PjWorkshop
    - - jvx.geom.PwBlocks

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, PsUpdateIf, PjWorkshopIf

      public class PwBlocks
      extends PjWorkshop

  Workshop class to discretize any PgElementSet into blocks.
  See Also:
    Serialized Form
  Author:
    Ulrich Reitebuch
  Version:
    20.09.12, 1.02 revised (fk) Use more natural element colors, shorten source code.
    20.09.03, 1.01 revised (kp) Name of default texture block image is now a static variable.
    18.09.02, 1.00 created (ur)

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.awt.Color[]` | `COLOR_TABLE` Used block colors, average pixel values of block texture
    `static java.lang.String` | `m_defBlocks` Default texture for quadrilateral and higher elements.

    - ### Fields inherited from class jv.object.PsObject

      `HAS_BOUNDARY_PANEL, HAS_CONFIG_PANEL, HAS_INFO_PANEL, HAS_LABEL_PANEL, HAS_MATERIAL_PANEL, HAS_TEXTURE_PANEL, HAS_VECTOR_PANEL, INSPECTOR_INFO, INSPECTOR_INFO_EXT, IS_DELETED, IS_FIXED, IS_FOCUSSED, IS_PICKED, IS_SELECTED, IS_USED, NUM_TAGS`

    - ### Fields inherited from interface jv.project.PjWorkshopIf

      `MODE_BUG, MODE_STANDARD, MODE_VALIDATE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PwBlocks()` Constructor.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int[][]` | `blocks()` Discretize the workshop's geometry to a geometry built from cubes.
    `boolean[][][]` | `getUsedBlocks(int[][] intCoordinates)` Get bits for being used for every cube of the discretization.
    `void` | `reset()` Compute size of blocks.
    `void` | `setDiscr(int discr)` Set global discretization for axes.
    `void` | `setDiscr(int dimIndex, int discr)` Set an individual discretization for one axis direction.
    `void` | `setGeometry(PgElementSet geom)` Assign a geometry, on which the workshop operates.

    - ### Methods inherited from class jvx.project.PjWorkshop

      `cancel, close, getDisplay, getDisplays, getGeometry, getMode, getSavedGeometry, getViewer, init, isModal, isStandalone, ok, removeGeometry, setDisplay, setDisplays, setGeometry, setModal, setMode, setStandalone, setViewer, update`

    - ### Methods inherited from class jv.object.PsObject

      `addInspector, addUpdateListener, assureInspector, clearTag, clone, clone, clone, copy, getFather, getInfoPanel, getInspector, getName, getNumObjects, getSymbol, hasInspector, hasTag, hasUpdateListener, instanceOf, instanceOf, newInspector, newInspector, removeInspector, removeInspector, removeUpdateListener, setName, setParent, setSymbol, setTag, toString, updatePanels`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface jv.object.PsUpdateIf

      `getFather, getName, setParent`

- - ### Field Detail

    - #### COLOR_TABLE

          public static final java.awt.Color[] COLOR_TABLE

      Used block colors, average pixel values of block texture

    - #### m_defBlocks

          public static java.lang.String m_defBlocks

      Default texture for quadrilateral and higher elements.

  - ### Constructor Detail

    - #### PwBlocks

          public PwBlocks()

      Constructor.

  - ### Method Detail

    - #### setGeometry

          public void setGeometry(PgElementSet geom)

      Assign a geometry, on which the workshop operates.

    - #### setDiscr

          public void setDiscr(int discr)

      Set global discretization for axes.

    - #### setDiscr

          public void setDiscr(int dimIndex,
                               int discr)

      Set an individual discretization for one axis direction.

    - #### reset

          public void reset()

      Compute size of blocks.
      Overrides:
        `reset` in class `PjWorkshop`

    - #### blocks

          public int[][] blocks()

      Discretize the workshop's geometry to a geometry built from cubes.
      Author:
        Ulrich Reitebuch
      Version:
        18.09.02, 1.00 created (ur)

    - #### getUsedBlocks

          public boolean[][][] getUsedBlocks(int[][] intCoordinates)

      Get bits for being used for every cube of the discretization.
      Author:
        Ulrich Reitebuch
      Version:
        18.09.02, 1.00 created (ur)

"

The software JavaView? is copyright protected. All Rights Reserved.
"